#SingleInstance force

!F1::
; Reload the script when you make changes
reload
return

!s::
suspend toggle
return

!q::
ExitApp
return

!f::
InitGui()
return

ButtonFLAX:
Gui, Submit
; Validate input
if (!((cycles => 1) && (cycles <= 50))) {
	MsgBox "Please enter a valid number of cycles"
	Gui, Show
	return
}

if (!((weedings > 0) && (weedings < 10))) {
	MsgBox "Please enter a valid number of weedings"
	Gui, Show
	return
}

if (dimension > 5) {
	MsgBox "Make sure your number of objects setting is maxed in video options"
}

Gui, Destroy

;Make sure it's an integer
cycles //= 1
weedings //= 1

Flax()
return


InitGui()
{
	global cycles
	global weedings
	global dimension

	Gui, Add, Text,, Number of harvest cycles:
	Gui, Add, Edit, vcycles wp, 3
	Gui, Add, Text,, Number of weedings required (including harvest):
	Gui, Add, Edit, vweedings, 3
	Gui, Add, Text,, Plot dimensions (NxN):
	Gui, Add, DropDownList, vdimension Choose2, 3|5|7
	Gui, Add, Button, Default, FLAX
	Gui, Show
}


Flax()
{

	global Xcenter
	global Ycenter
	global width
	global cycles
	global weedings
	global dimension

	message := "Please close your friends list and minimize chat and stat tabs in order to ensure proper macroage.`n"
	message .= "Ensure that ATITD is maximized and that Hotkeys on Flax is disabled`n"
	message .= "Also disable camera moves very fast and camera moves unreasonably fast.`n`n"
	message .= "Pin the plant menu at the very top left corner of the screen`n`n"
	message .= "IN CASE OF EMERGENCY: HIT ALT-Q"
	MsgBox,,, %message%, 5

	; Wait for the window to become active, then get the window stats
	WinWait, eGenesis Client, 
	IfWinNotActive, eGenesis Client, , WinActivate, eGenesis Client, 
	WinWaitActive, eGenesis Client,
	WinGetActiveStats, win_Title, Xmax, Ymax, win_Xpos, win_Ypos

	Send {F5}{F8}{F8}
	MouseMove, 0,0
	Sleep 5000
	MouseMove, 0, 0
	Sleep 5000
	Xcenter := Xmax//2 - 3
	Ycenter := Ymax//2 + 16
	;Flax beds are ~55 coords wide at this zoom level
	width := 55
	MouseMove, Xcenter, Ycenter, 0

	Loop 9 {
		MouseClick, WheelDown
		Sleep 1000
	}

Loop %cycles%
{
	Sleep 500
	i = 0
	Loop {	
		i += 1
		Plant_Row("right", dimension)
		Move("down")
		if (i >= dimension)
			break

		i += 1
		Plant_Row("left", dimension)
		Move("down")
		if (i >= dimension)
			break
	}

	half_dim := dimension//2
	; Rip up middle bed so we can stand there
	Rip(half_dim)

	Move("left", half_dim)
	Move("up", half_dim + 1)

	Loop %weedings%
	{
		Loop %dimension%
		{
			j := A_Index - half_dim - 1
			Loop %dimension%
			{
				i := A_Index - half_dim - 1
				; Alternate directions
				if (Mod(Abs(j), 2) == 0) {
					i *= -1
				}
				; Don't try to weed ripped out bed
				if ((i == 0) && (j == 0))
					continue

				Weed(i, j)
				Sleep 370
			}
		}
	}
	Sleep 1000
	Move("left", half_dim)
	Move("up", half_dim)
; end of cycle loop
}
; end of function
}


Weed(x, y)
{
	global width
	global Xcenter
	global Ycenter

	x *= (width + 2)
	x += Xcenter + 10
	y *= width
	y += Ycenter

	; Display the menu
	MouseMove, x, y, 0
	Sleep 20
	MouseClick, Right

	; Redisplay until "weed" appears
if (oldversion) {
	Loop {
		Sleep 20
		PixelGetColor, color, (x + 20), y
		R := color & 0xFF0000
		R >>= 16
		G := color & 0x00FF00
		G >>= 8
		B := color & 0x0000FF

		if ((R > 0) && (R < 120) && (B < 120) && (G < 120)) {
			Sleep 50
			MouseMove, x, y, 0
			Sleep 20
			MouseClick, Right
			continue
		} else {
			break
		}
	}
} else {
	Loop {
		Sleep 20
		x1 := x
		y1 := y - 60
		x2 := x + 200
		y2 := y + 60
		ImageSearch,,, x1, y1, x2, y2, *50 Find_Weed.png
		if (errorlevel == 0) {
			break
		} else if (errorlevel == 2) {
			MsgBox ZOMG BROKEN
		}
		ImageSearch,,, x1, y1, x2, y2, *50 Find_Harvest_This.png
		if (errorlevel == 0) {
			break
		}

		; Didn't find either, redisplay menu and retry
		Sleep 30
		MouseMove, x, y, 0
		Sleep 20
		MouseClick, Right
		continue
	}
}

	; Click "weed"
	MouseClick, Right, (x + 30), (y - 6),,0
}


Rip(mult)
{
	global width
	global Xcenter
	global Ycenter

	x := -(width * mult)
	y := -((width * mult) + (width - 10))
	MouseMove, Xcenter, Ycenter, 0
	Sleep 100
	MouseMove,x, y, 0, R
	Sleep 100
	MouseClick
	Sleep 100
	MouseClick,, 20, 10,, 0,, R
	Sleep 100
	MouseClick,, 20, -10,, 0,, R
	Sleep 200
	MouseClick,, Xcenter, Ycenter,, 0
	Sleep 200
	MouseClick,Right , 0, 100,, 0,, R
	Sleep 100
}


Move(direction, count = 1) {
	global width
	global Xcenter
	global Ycenter

	distance := width * count
	time := 650 * count
	MouseMove, Xcenter, Ycenter, 0

	if (direction == "right") {
		MouseClick,, distance, 0,, 0,, R
	} else if (direction == "left") {
		MouseClick,, -(distance), 0,, 0,, R
	} else if (direction == "down") {
		MouseClick,, 0, distance,, 0,, R
	} else if (direction == "up") {
		MouseClick,, 0, -(distance),, 0,, R
	}
	Sleep %time%
}
	

Plant_Row(direction, num)
{
	MouseClick,, 40, 40,, 0
	if (num <= 0) {
		return
	}
	num -= 1
	Loop %num% {
		Move(direction)
		MouseClick,, 40, 40,, 0
	}
	return
}

GuiClose:
Gui, Destroy
return